<?
 // passwortschutz (One-User-Version)
 // Autor: Christian@Rotzoll.de

 ////////////////////////////////////////////
 ////////////  PASSWORT KLASSE

 class passControl {


   ////////////////////////////////////////////
   ////////////  INIT EINSTELLUNGEN
   ///////////   (Nach dem ndern, ggf. die Datei passControll_DATA.php lschen)

   // Name der Seite, die geladen wird, wenn der User sich einloggen soll
   var $LOGIN_PAGE = "";

   // Zeit in Sekunden nachdem eine gltige Session verfllt
   var $SESSIONTIMEOUT = 3600; // 3600 = 1 Stunde

   // Startpassword
   var $password  = "init";
   //---------------------------

  var $sessionid = "";
  var $timeOfLastAction = 0;

  function logout()
  {
    $this->sessionid = md5(time());
    $this->saveThisObject();
  }

  function setNewPassword($newPass)
  {
    $this->password=$newPass;
    $this->saveThisObject();
  }

  function checkPassword($passwordToCheck)
  {
    if ($this->password == $passwordToCheck)
    { // Passwort stimmt

      // neue SessionID anlegen
      $this->sessionid = md5(time());
      $this->timeOfLastAction = time();
      $this->saveThisObject();

      // SessionID zurckgeben
      return TRUE;
    }
    else
    {
      // Passwort ist falsch
      return FALSE;
    }
  }

  function checkSessionID($idToCheck)
  {
    if ($this->sessionid!="")
    { // es ist bereits eine letzte SessionID im Objekt gespeichert
       if ($this->sessionid==$idToCheck)
       { // die vom User bermittelte SessionID stimmt mit der gespeicherten berein
         // Die ist eindeutig identifiziert und zugriffsberechtigt
         if ($this->testSessionTimeout())
         {
           return FALSE;
         }
         else
         {
           $this->timeOfLastAction = time();
           $this->saveThisObject();
           return TRUE;
         }
       }
       else
       { // die von User bermittelte SessionID stimmt mit der gespeicherten NICHT berein
         return FALSE;
       }
    }
    else
    { // es ist noch keine SessionID gespeichert
      return FALSE;
    }
  }

  function saveThisObject()
  {
    // Dieses Objekt (mit seinen Daten) in einen String umwandeln
    $objectAsString = serialize($this);

    // Den ObjektString speichern
    $dat = fopen("./Data/passControl_DATA.php","w");
      fwrite($dat,"<? // Daten von passControl.php - NICHT EDITIEREN!! \n".$objectAsString."\n?>Finger wech du Schelm!");
    fclose($dat);

    if (!file_exists("./Data/passControl_DATA.php"))
    {
      echo "passControl.php : Es koennen keine Daten gespeichert werden. Bitte Schreibrechte aktivieren.";
      exit();
    }
  }

  // Gibt TRUE zurck, wenn die Session abgelaufen ist
  function testSessionTimeout()
  {
    if ((time() - $this->timeOfLastAction) <= $this->SESSIONTIMEOUT)
    {
      return FALSE;
    }
    else
    {
      echo"<!Sessiontimeout:".(time() - $this->timeOfLastAction)." groeer ".$this->SESSIONTIMEOUT.">";
      return TRUE;
    }
  }

 } // END class passControl


 ////////////////////////////////////////////
 ////////////  STATISCHE FUNKTIONEN

 function loadPasswordContolObject()
 {
    if (file_exists("./Data/passControl_DATA.php"))
    {
      $fileArray = file("./Data/passControl_DATA.php");
      return unserialize($fileArray[1]);
    }
    else
    {
      return new passControl;
    }
 }

 // prft ob die der Parameter 'varname' mit POST oder GET dem Script bergeben wurde
 function issetPostGet($varname)
 {
   if ( isset($_POST[$varname]) )
   {
     return TRUE;
   }
   else if ( isset($_GET[$varname]) )
   {
     return TRUE;
   }
   return FALSE;
 }

 // gibt den STRING 'varname', der mit POST oder GET dem Script bergeben wurde, zurck
 function getPostGetText($varname)
 {
   if ( isset($_POST[$varname]) )
   {
     return htmlspecialchars($_POST[$varname]);
   }
   else if ( isset($_GET[$varname]) )
   {
     return htmlspecialchars($_GET[$varname]);
   }
   return "";
 }

 // gibt den INTEGER 'varname', der mit POST oder GET dem Script bergeben wurde, zurck
 function getPostGetInt($varname)
 {
   if ( isset($_POST[$varname]) )
   {
     return intval($_POST[$varname]);
   }
   else if ( isset($_GET[$varname]) )
   {
     return intval($_GET[$varname]);
   }
   return 0;
 }

 // gibt den Namen des Scriptes zurck, dass in der URL aufgerufen wurde
 function getMasterScriptName()
 {
     if (strrpos($_SERVER['SCRIPT_NAME'],"/")!=0)
     {
       return substr($_SERVER['SCRIPT_NAME'], strrpos($_SERVER['SCRIPT_NAME'],"/")+1);
     }
     else
     {
       return $_SERVER['SCRIPT_NAME'];
     }
 }

 // gibt default Passwort-Formular aus
 function echoPassForm()
 {
  ?>
     <center><br><b>
       Bitte Passwort eingeben:<br>
       <?  echo "<form action='".getMasterScriptName()."'>"; ?>
         <input name="loginpassword" type="password" size="15" maxlength="15">
       </form>
     </b></center>
  <?
 }

 ////////////////////////////////////////////
 ////////////  HAUPTFUNKTION

function activate_passControl()
{

 // lade controlPasswort-Objekt
 $PWObject = loadPasswordContolObject();

 if (issetPostGet("sessionID"))
 { // dem Script wurde eine sessionID bergeben

   if (!$PWObject->checkSessionID(getPostGetText("sessionID")))
   {
     echo "passControl.php : Sie verwenden eine ungueltige SessionID!!!";
     if ( $PWObject->LOGIN_PAGE=="")
     {
       echo " <a href='".getMasterScriptName()."'>Bitte erneut einloggen.</a>";
     }
     else
     {
       echo " <a href='".$LOGIN_PAGE."'>Bitte erneut einloggen.</a>";
     }
     exit();
   }
   else
   {
     // Alles OK.
     $SESSIONID = $PWObject->sessionid;
     return $PWObject;
   }

 }

 else if (issetPostGet("loginpassword"))
 { // dem Script wurde ein LoginPasswort bergeben

   if (!$PWObject->checkPassword(getPostGetText("loginpassword")))
   {
     // Passwort ist UNGLTIG
     ?>
     <html><body><center><b>Passwort ist falsch!! Bitte erneut versuchen.</b><br>
     <?
     if ( $PWObject->LOGIN_PAGE=="")
     {
       echoPassForm();
     }
     else
     {
       echo "<a href='".$PWObject->LOGIN_PAGE."'>Zum Login.</a>";
     }
     ?>
     </center></body></html>
     <?

     exit();
   }
   else
   {
     // Passwort ist gltig
     return $PWObject;
   }
 }

 else
 { // der User hat sich weder ber eine SessioID noch ber ein Passwort identifiziert
   if ($PWObject->LOGIN_PAGE=="")
   {
     // Passworteingabe in HTML ausgeben
     ?>
     <html><body>
       <? echoPassForm(); ?>
     </body></html>
     <?
   }
   else
   {
     echo "<a href='".$PWObject->LOGIN_PAGE."'>Zum Login.</a>";
   }
   exit();
 }
}


?>